#include <iostream>
#include <stack>
#include "Multiply.h"
#include "Add.h"
#include "Subtract.h"

using namespace std;

int main()
{
    // Stack je asi nejvhodnejsi kontejner
    // Poradi vkladani odpovida poradi vyhodnoceni pri zapisu a(b(c(x)))
    // tedy operace se volaji v opacnem poradi nez jsou vkladany
    stack<COperation*> operations;
    operations.push(new CMultiply(-2));
    operations.push(new CSubtract(10));
    operations.push(new CAdd(1));

    int partial = 3;
    while(!operations.empty())
    {
        COperation *op = operations.top();
        operations.pop();
        partial = (*op)(partial);
        delete op;
    }


    cout << partial << endl;
    return 0;
}
